PriorEstim<-function(Estim,Ind){
 alpha0<-mean(Estim$s[Ind]^2)^2/var(Estim$s[Ind]^2)+2
 beta0<-(alpha0-1)*mean(Estim$s[Ind]^2)
 theta0<-apply(Estim$thet[,Ind],1,mean)
 V0<-cov(t(diag(1/Estim$Scale)%*%Estim$thet[,Ind]))*(alpha0-1)/beta0 #from marginal t-distr
 V00<-cov(t(Estim$thet[,Ind]))*(alpha0-1)/beta0 
 list(thet=theta0,V=V00,VScal=V0,alph=alpha0,bet=beta0,Scale=Estim$Scale) #V0 Prior for scaled problem
}

PriorUncEst<-function(Estim,Ind){
 IGMean<-mean(Estim$bet[Ind]/(Estim$alph[Ind]-1))
 IGVar<-mean(Estim$bet[Ind]^2/(Estim$alph[Ind]-1)^2/(Estim$alph[Ind]-2))+
  var(Estim$bet[Ind]/(Estim$alph[Ind]-1))*(length(Ind)-1)/length(Ind)
 alpha0<-IGMean^2/IGVar+2
 beta0<-(alpha0-1)*IGMean
 theta0<-apply(Estim$thet[,Ind],1,mean)
# V00<-apply(Estim$V[,,Ind],c(1,2),mean)+(Estim$thet[,Ind]-theta0)%*%t(Estim$thet[,Ind]-theta0)/length(Ind) #fitting a mvt-Nomral to sum of MVT-N's
 Term<-array(0,dim=dim(Estim$V[,,Ind]))
 for (i in 1:length(Ind)){
  Term[,,i]<-Estim$bet[Ind[i]]/(Estim$alph[Ind[i]]-1)*Estim$V[,,Ind[i]]
 }
 V00<-(alpha0-1)/beta0*(apply(Term,c(1,2),mean)+(Estim$thet[,Ind]-theta0)%*%t(Estim$thet[,Ind]-theta0)/length(Ind)) #fitting a mvt-t to sum of MVT-t's
 V0<-diag(1/Estim$Scale)%*%V00%*%diag(1/Estim$Scale)
 list(thet=theta0,V=V00,VScal=V0,alph=alpha0,bet=beta0,Scale=Estim$Scale) #V0 Prior for scaled problem
}

AddDistr2Plot<-function(Distr,L,Farb="red",lity=1,Labels=1,Label,Lwd=1){
 for (j in 1:(ncol(L[[1]])-1)){
  screen(j,new=FALSE)
  plot(0,0,xlim=L$Limitsx[,j],ylim=L$Limitsy[,j],col="white",xlab="",ylab="",pch=NA)
  if (Labels){
   title(xlab=Label[j],line=2.5)
   if (j==1 || j==4){
    title(ylab=Label[length(Label)],line=2.5)
   }
  }
  xx<-seq(from=L$Limitsx[1,j],to=L$Limitsx[2,j],length=100)
  V2<-c(Distr$bet/Distr$alph)*Distr$V
  nu<-2*Distr$alph
  if (j<(ncol(L[[1]])-1)){
   yy<-dt((xx-Distr$thet[j])/sqrt(V2[j,j]),df=nu)/sqrt(V2[j,j])
  }else{
   yy<-2*xx*dinvgamma(xx^2,shape=Distr$alph,scale=Distr$bet)
  }
  lines(xx,yy,col=Farb,lty=lity,lwd=Lwd)
 }
}

AddRegr<-function(Regr,L,fct="line",degree=1,Farb="gray",lity=1,Lwd=2){
 xx<-seq(min(L$Limitsx[,ncol(L$Limitsx)]),max(L$Limitsx[,ncol(L$Limitsx)]),length=1000)
 D<-Design(x=xx,fct=fct,degree=degree,Scal=FALSE)
 yy<-D$X%*%Regr$thet
 vv<-diag(D$X%*%Regr$V%*%t(D$X))
# abline(a=Regr$thet[1],b=Regr$thet[2],lwd=3,col=Farb,lty=lity)
 lines(xx,yy,col=Farb,lty=lity,lwd=Lwd)
 #t-distr at location theta0[1]+theta0[2]*x with scale^2 beta0/alpha0*V0[1,1]+V0[2,2]*x^2
 param<-cbind(mu=yy,delta=sqrt(Regr$bet/Regr$alph*vv))
 lines(xx,qt(p=0.025,df=2*Regr$alph)*param[,2]+param[,1],lty=2,lwd=Lwd,col=Farb)
 lines(xx,qt(p=0.975,df=2*Regr$alph)*param[,2]+param[,1],lty=2,lwd=Lwd,col=Farb)
}
