ReadData<-function(Path1,Path2,File="d1-data.txt"){
 setwd(Path1)
 #read in data
 Hilf<-read.csv(File,header=FALSE,sep="")
 x<-list()
 y<-list()
 for (i in 1:5){
  x<-c(x,list(Hilf[which(Hilf[,3]==i),1]))
  y<-c(y,list(Hilf[which(Hilf[,3]==i),2]))
 }
 setwd(Path2)
 list(x=x,y=y)
}

#plot data
PlotData<-function(x,y,Fit,Ind,fct="line",degree=1,Farb,SubInd=NA,FullRange=TRUE,YFac=0.0001,Offset=0,Label=c("Normal linear regression","x","y")){
 if (FullRange){
  LimX<-c(min(unlist(x)),max(unlist(x)))
  LimY<-c(min(unlist(y)),max(unlist(y)))
 }else{
  LimX<-c(min(x[[Ind]][SubInd])*0.995,max(x[[Ind]][SubInd])*1.005)
  LimY<-Offset+c(min(y[[Ind]][SubInd])-abs(YFac*min(y[[Ind]][SubInd])),max(y[[Ind]][SubInd])+abs(YFac*max(y[[Ind]][SubInd])))
 }
 plot(0,0,xlim=LimX,ylim=LimY,col="white",xlab="",ylab="",main="")
 title(xlab=Label[2],ylab=Label[3],line=2.5)
 title(main=Label[1],line=1)
 xx<-seq(LimX[1],LimX[2],length=100)
 if (!is.numeric(SubInd)){
  for (i in 1:length(Ind)){
   points(x[[Ind[i]]],y[[Ind[i]]],col=Farb[Ind[i]])
   yy<-0
   if (fct=="line"){
#     abline(a=Fit$thet[1,Ind[i]],b=Fit$thet[2,Ind[i]],col=Farb[Ind[i]]) 
    for (j in 0:degree){
     yy<-yy+Fit$thet[j+1,Ind[i]]*xx^j
    }
   }else{
    for (j in (1:length(degree))){
     yy<-yy+Fit$thet[j,Ind[i]]*xx^degree[j]
    }
   }
   lines(xx,yy,col=Farb[Ind[i]])
  }
 }else{
  points(x[[Ind]][SubInd],y[[Ind]][SubInd],col=Farb[Ind])
 }
}
